ON_Hatch Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_hatch.h>`

Inheritance diagram for ON_Hatch:

## Public Member Functions

| ON_Hatch ()
| ON_Hatch (const ON_Hatch &)
ON_Hatch & | operator= (const ON_Hatch &)
| ~ON_Hatch ()
virtual ON_Hatch * | DuplicateHatch () const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | Transform (const ON_Xform &)
bool | Create (const ON_Plane &plane, const ON_SimpleArray< const ON_Curve * > loops, int pattern_index, double pattern_rotation, double pattern_scale)
const ON_Plane & | Plane () const
void | SetPlane (const ON_Plane &plane)
double | PatternRotation () const
void | SetPatternRotation (double rotation)
double | PatternScale () const
void | SetPatternScale (double scale)
int | LoopCount () const
void | AddLoop (ON_HatchLoop *loop)
bool | InsertLoop (int index, ON_HatchLoop *loop)
bool | RemoveLoop (int index)
const ON_HatchLoop * | Loop (int index) const
ON_Curve * | LoopCurve3d (int index) const
int | PatternIndex () const
void | SetPatternIndex (int index)
void | SetBasePoint (ON_2dPoint basepoint)
void | SetBasePoint (ON_3dPoint point)
ON_3dPoint | BasePoint () const
ON_2dPoint | BasePoint2d () const
bool | ReplaceLoops (ON_SimpleArray< const ON_Curve * > loops)
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Protected Member Functions

class ON_HatchExtra * | HatchExtension ()

## Protected Attributes

ON_Plane | m_plane
double | m_pattern_scale
double | m_pattern_rotation
ON_SimpleArray< ON_HatchLoop * > | m_loops
int | m_pattern_index

## Detailed Description

Definition at line 524 of file opennurbs_hatch.h.

## Constructor & Destructor Documentation

ON_Hatch::ON_Hatch | ( |  | ) |

ON_Hatch::ON_Hatch | ( | const ON_Hatch & |  | ) |

ON_Hatch::~ON_Hatch | ( |  | ) |

## Member Function Documentation

void ON_Hatch::AddLoop | ( | ON_HatchLoop * | loop | ) |

ON_3dPoint ON_Hatch::BasePoint | ( |  | ) | const

ON_2dPoint ON_Hatch::BasePoint2d | ( |  | ) | const

bool ON_Hatch::Create | ( | const ON_Plane & | plane,
|  | const ON_SimpleArray< const ON_Curve * > | loops,
|  | int | pattern_index,
|  | double | pattern_rotation,
|  | double | pattern_scale
| ) |  |

int ON_Hatch::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

void ON_Hatch::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

virtual ON_Hatch* ON_Hatch::DuplicateHatch | ( |  | ) | const

virtual

ON_BOOL32 ON_Hatch::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

bool ON_Hatch::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented from ON_Geometry.

class ON_HatchExtra* ON_Hatch::HatchExtension | ( |  | ) |

protected

bool ON_Hatch::InsertLoop | ( | int | index,
|  | ON_HatchLoop * | loop
| ) |  |

ON_BOOL32 ON_Hatch::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

const ON_HatchLoop* ON_Hatch::Loop | ( | int | index | ) | const

int ON_Hatch::LoopCount | ( |  | ) | const

ON_Curve* ON_Hatch::LoopCurve3d | ( | int | index | ) | const

ON::object_type ON_Hatch::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

ON_Hatch& ON_Hatch::operator= | ( | const ON_Hatch & |  | ) |

int ON_Hatch::PatternIndex | ( |  | ) | const

double ON_Hatch::PatternRotation | ( |  | ) | const

double ON_Hatch::PatternScale | ( |  | ) | const

const ON_Plane& ON_Hatch::Plane | ( |  | ) | const

ON_BOOL32 ON_Hatch::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

bool ON_Hatch::RemoveLoop | ( | int | index | ) |

bool ON_Hatch::ReplaceLoops | ( | ON_SimpleArray< const ON_Curve * > | loops | ) |

void ON_Hatch::SetBasePoint | ( | ON_2dPoint | basepoint | ) |

void ON_Hatch::SetBasePoint | ( | ON_3dPoint | point | ) |

void ON_Hatch::SetPatternIndex | ( | int | index | ) |

void ON_Hatch::SetPatternRotation | ( | double | rotation | ) |

void ON_Hatch::SetPatternScale | ( | double | scale | ) |

void ON_Hatch::SetPlane | ( | const ON_Plane & | plane | ) |

ON_BOOL32 ON_Hatch::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

ON_BOOL32 ON_Hatch::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

ON_SimpleArray<ON_HatchLoop*> ON_Hatch::m_loops

protected

Definition at line 825 of file opennurbs_hatch.h.

int ON_Hatch::m_pattern_index

protected

Definition at line 826 of file opennurbs_hatch.h.

double ON_Hatch::m_pattern_rotation

protected

Definition at line 824 of file opennurbs_hatch.h.

double ON_Hatch::m_pattern_scale

protected

Definition at line 823 of file opennurbs_hatch.h.

ON_Plane ON_Hatch::m_plane

protected

Definition at line 822 of file opennurbs_hatch.h.

The documentation for this class was generated from the following file:

- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_hatch.h